"use strict";
this.name = "vector_benus";
this.author = "Svengali";
this.copyright = "CC-by-nd-sa-3.0";
this.description = "Benus Triadon";
this.version = "1.7.2";

this.shipSpawned = function()
{
	if(worldScripts.vector.logging) log(this.name,this.name+': Benus entered system. Uh, trouble.');
	if(this.ship.primaryRole==="trader"){this.ship.setScript("oolite-default-ship-script.js"); this.ship.switchAI("route1traderAI.plist"); return;}
	this.commChannel = {display:"Benus Triadon",who:this.ship,ent:true,pID:this.ship.entityPersonality,callback:"commCall",
		react:[{display:"Hail"},{display:"Direction"},{display:"Safety"},{display:"Back"}]};
	this.pflag = false;
	this.aflag = false;
	this.sflag = false;
	this.chatter = 1;
	this.ship.primaryRole==='trader';
	this.ov = new worldScripts.vector_news.VectorOV();
	this.ov.addCharacterOVOff('14');
	if(Math.random()>0.5){
		system.addShips('thargoid',2,this.ship.position,25000.0);
		player.commsMessage("Mayday! Thargoids are attacking. Position marked (X). Send help!");
		this.mark = system.addShips('vector_mark',1,this.ship.position.add([0,0,300]),100)[0];
	}
	this.bla = ["Oh boy - good work. Please stay close.",
		"Good work! Please stay close, we need some support.",
		"Please escort us. I can smell that there are still some of them.",
		"Rock on! Please stay close."];
	return;
}
this.shipBeingAttacked = function(whom)
{
	if(!player.ship.isValid) return;
	if(whom && whom.isPlayer){
		if(!this.pflag && this.chatter>0) worldScripts.Cabal_Common_Comms.removeFromComm(this.commChannel);
		this.chatter = 0;
		this.pflag = true;
		if(this.mark && this.mark.isValid) this.mark.explode();
	} else {
		this.aflag = true;
		if(this.chatter==1 && this.ship.position.distanceTo(player.ship.position)<23000){
			this.ship.displayName = "Benus Triadon";
			this.ov.addOv(1,'07',null,null,1);
			worldScripts.Cabal_Common_Comms.addToComm(this.commChannel);
			this.chatbox(1);
			this.chatter = 2;
			var cols = worldScripts.vector.myColor;
			this.ship.scannerDisplayColor1 = cols[0];
			this.ship.scannerDisplayColor2 = cols[1];
			if(this.mark && this.mark.isValid) this.mark.explode();
		}
	}
	return;
}
this.shipEnergyBecameFull = this.shipTargetDestroyed = this.shipTargetLost = function()
{
	if(!this.ship.isPiloted || this.ship.isDerelict || !player.ship.isValid) return;
	var enemy = this.getArea();
	if(enemy.length){
		for(let i=0;i<enemy.length;i++){
			if(enemy[i].isValid){
				this.aflag = true;
				this.ship.target = enemy[i];
				this.ship.reactToAIMessage("TARGET_FOUND");
				break;
			}
		}
	} else {
		this.aflag = false;
		this.placeNewSet();
		if(this.ship.position.distanceTo(player.ship.position)<23000 && this.chatter==2) this.chatter = 3;
	}
	return;
}
this.isOuch = function(entity)
{
	return(entity.isShip && !entity.isPlayer && !entity.hasSuspendedAI && !entity.isCargo && !entity.isRock && !entity.isDerelict && (entity.bounty>0 || entity.primaryRole==='pirate' || (entity.target==this.ship && entity.group!=this.ship.group)));
}
this.getArea = function()
{
	return system.filteredEntities(this,this.isOuch,this.ship,25600);
}
this.shipEnteredStationAegis = this.shipEnteredPlanetaryVicinity = function()
{
	if(!player.ship.isValid) return;
	if(this.ship.position.distanceTo(player.ship.position)<23000){
		if(this.chatter>1){
			if(this.chatter!=2) this.chatbox(4);
			this.placeNewSet();
			this.ship.reactToAIMessage("SPEED_UP_MORE");
		}
	}
	return;
}
this.shipWillDockWithStation = function()
{
	if(!player.ship.isValid) return;
	if(this.mark && this.mark.isValid) this.mark.explode();
	worldScripts.Cabal_Common_Comms.removeFromComm(this.commChannel);
	if(this.ship.position.distanceTo(player.ship.position)<23000){
		if(!player.ship.docked){
			if(this.chatter>1){
				this.chatbox(3);
				worldScripts.vector_pad.addToLogbook("AAB "+system.name,"AAC");
				worldScripts.vector_pad.showBenus = true;
			}
		} else player.commsMessage("Benus here. You should have waited for me. Next time then...");
	}
	return;
}
this.shipDied = this.shipLaunchedEscapePod = function()
{
	if(!player.ship.isValid) return;
	player.commsMessage("Aaargh..");
	if(this.mark && this.mark.isValid) this.mark.explode();
	worldScripts.Cabal_Common_Comms.removeFromComm(this.commChannel);
	return;
}
this.chatbox = function(m)
{
	if(!player.ship.isValid || this.pflag) return;
	if(typeof(m)==='object' && (this.ship.position.distanceTo(player.ship.position)>23000 || this.chatter<2)) return;
	if(m){
		var speak,sound;
		if(typeof(m)==='object'){
			if(this.chatter>1) speak = "Uff. Station reached. Requesting slot now. Wait until I'm docked, ok?";
		} else {
			switch(m){
				case 1: speak = "Over here, Commander. Please help!"; sound = '[vector_benusA]'; break;
				case 3: this.ov.addOv(null,'14',1,null,"Will meet you in a minute on the bar."); break;
				case 4: speak = "Yeeha. Only a quick hop now. We should have some drinks together."; break;
			}
		}
	} else {
		if(this.ship.position.distanceTo(player.ship.position)>23000 || this.chatter<2 || this.aflag) return;
		if(this.bla.length){speak = this.bla[0]; this.bla.shift();}
	}
	if(speak){
		if(sound) this.ov.addOv(null,'14',1,null,{ent:this.ship,message:speak},sound);
		else this.ov.addOv(null,'14',1,null,{ent:this.ship,message:speak},'[vector_benusB]');
	}
	return;
}
this.placeNewSet = function()
{
	if(this.mark && this.mark.isValid) this.mark.explode();
	if(!this.sflag && !this.pflag){
		this.sflag = true;
		var newSet = [{display:"Hail"},{display:"Direction"},{display:"Safety"},{display:"Help"},{display:"Speed up"},{display:"Back"}];
		worldScripts.Cabal_Common_Comms.changeChoicesComm(this.commChannel.pID,newSet);
		this.commChannel.react = newSet;
	}
	return;
}
this.commCall = function(action)
{
	if(this.pflag || this.ship.position.distanceTo(player.ship.position)>25000) return;
	var m=null;
	switch(action){
		case 0: if(this.aflag) m = '[vector_commhailB]'; else m = '[vector_commhailA]'; break;
		case 1: if(this.aflag) m = '[vector_commdirectionB]'; else m = '[vector_commdirectionA]'; break;
		case 2: if(this.aflag) m = '[vector_commsafetyB]'; else m = '[vector_commsafetyA]'; break;
		case 3: 
			if(this.aflag) m = '[vector_commhelpC]';
			else {
				if(player.ship.hasHostileTarget || player.alertCondition===3){
					if(player.ship.target && player.ship.target!=this.ship && player.ship.target.bounty){
						this.ship.target = player.ship.target;
						this.ship.reactToAIMessage("ATTACKED");
					}
					m = '[vector_commhelpB]';
				} else m = '[vector_commhelpD]';
			}
			break;
		case 4:
			if(player.ship.maxSpeed>340 && !this.aflag){
				if(this.ship.position.distanceTo(system.mainStation.position)>25000){
					m = '[vector_commbenusspeedA]';
					if(!this.ship.fuel) this.ship.fuel+=1;
					this.ship.reactToAIMessage("SPEED_UP_MORE");
					break;
				}
			}
			m = '[vector_commbenusspeedB]';
			break;
	}
	if(m) this.ship.commsMessage(expandDescription(m));
	return;
}
