"use strict";
this.name = "vector_insp";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Inspection";
this.version = "1.7.1";

this.startUp = function()
{
	delete this.startUp;
	this.ov = new worldScripts.vector_news.VectorOV();
}
this.shipWillDockWithStation = function()
{
	if(this.inspectionTimer){this.inspectionTimer.stop(); delete this.inspectionTimer;}
	if(this.insp){
		if(this.insp.penalty) player.addMessageToArrivalReport("You're fined with "+this.insp.penalty+" Credits for trading in illegal goods.");
		if(this.insp.ins && this.insp.ins.isValid) this.insp.ins.remove();
		delete this.insp;
	}
}
this.startInspection = function(station,other)
{
	if(!player.ship.isValid || this.insp) return; // No double walk .-)
	if(player.bounty>7){
		let a = station;
		a.launchPatrol();
		player.commsMessage(station.name+": Give up, pirate! Over and out.");
		return;
	}
	if(worldScripts.vector.audio) this.mySound = new SoundSource;
	this.insp = new Object({wait:0,loop:0,warn:0,penalty:0,init:false,freight:0,station:station,time:clock.seconds,other:other});
	this.inspectionTimer = new Timer(this,this.doInspectionTimer,0,10);
	if(worldScripts["BGS-M"]) worldScripts["BGS-M"].bgsDisableChatter = true;
	return;
}
this.calculatePenalty = function(penalty)
{
	if(player.credits<=penalty) player.credits = Math.min(player.credits,30);
	else player.credits -= penalty;
	return;
}
this.doInspectionTimer = function()
{
	if(!player.ship.isValid || !this.insp.station.isValid){
		this.shipDied();
		return;
	}
	if(clock.isAdjusting || player.ship.position.distanceTo(this.insp.station)>17000){
		this.insp.time = clock.seconds;
		return;
	}
	if(this.insp.init){
		if(worldScripts["BGS-M"]) worldScripts["BGS-M"].bgsDisableChatter = true;
		if(!this.insp.freight){
			this.insp.wait = 0;
			this.insp.warn = 0;
			this.setSound(3);
			if(worldScripts.vector.andale && Math.random()>0.3){
				this.ov.addOv(null,'09',1,null,"Hmm, you're on my list. Sorry for the inconvenience, sir. Have a nice travel.","vector_insp_list.ogg");
				worldScripts.vector_pad.addToLogbook("BAB "+system.name);
				this.backFrom(3,1);
				delete this.insp;
				return;
			}
			++this.insp.freight;
			this.ov.addOv(null,'09',1,null,"Your documents seem to be ok. Let's take a look in your cargo hold.","vector_insp_look.ogg");
			return;
		} else {
			++this.insp.freight;
			if(this.insp.freight===2){
				if(manifest.slaves || manifest.narcotics || manifest.firearms){
					this.insp.penalty += manifest.slaves*20+manifest.narcotics*50+manifest.firearms*70;
					this.ov.addOv(null,'09',1,null,"Commander. Illegal goods found. Confiscated!","vector_insp_confiscated.ogg");
					manifest.slaves = 0;
					manifest.narcotics = 0;
					manifest.firearms = 0;
				} else if(this.insp.other){
					this.insp.penalty += this.insp.other.length*40;
					this.ov.addOv(null,'09',1,null,"Tss, tss. Special goods, eh? You know they are not legal here?","vector_insp_goods.ogg");
				} else this.ov.addOv(null,'09',1,null,"No illegal goods in your usual cargo hold found.","vector_insp_noillegal.ogg");
			} else if(this.insp.freight===3){
				this.insp.penalty += (worldScripts.vector_pad.padInfos.generic.epods*400+worldScripts.vector_pad.padInfos.generic.cpods*300);
				this.insp.penalty *= system.government+1;
				var a = false;
				if(worldScripts.vector_pad.padInfos.generic.epods) a = true;
				if(worldScripts.vector_pad.padInfos.generic.cpods) a = true;
				if(this.insp.penalty){
					if(a) this.ov.addOv(null,'09',1,null,"We have confiscated illegal goods. You are fined with "+this.insp.penalty+" Credits.","vector_insp_confiscatedfined.ogg");
					else this.ov.addOv(null,'09',1,null,"You are fined with "+this.insp.penalty+" Credits.","vector_insp_fined.ogg");
					worldScripts.vector_pad.addToLogbook("BAF");
					worldScripts.vector.calculatePenalty(this.insp.penalty);
					worldScripts.vector.dataRW();
				} else {
					this.ov.addOv(null,'09',1,null,"Nothing unusual found on your ship.","vector_insp_nothing.ogg");
					worldScripts.vector_pad.addToLogbook("BAA "+system.name);
				}
				return;
			} else if(this.insp.freight===4){
				this.ov.addOv(null,'09',1,null,"Inspection is over. Have a nice travel.","vector_insp_inspectionover.ogg");
			} else if(this.insp.freight>=5){
				this.backFrom(3,1);
				delete this.insp;
				return;
			}
		}
	} else {
		var timecheck = clock.seconds-this.insp.time;
		if(timecheck>400){
			this.backFrom(11,1);
			player.commsMessage(this.insp.station.name+": A technical malfunction has occured - aborting inspection. Sorry for inconveniences and have a nice journey. Over and out.");
			return;
		}
		if(this.insp.ins && !system.countShipsWithRole('vector_inspection')){
			this.insp.station.launchShipWithRole('vector_inspection',true);
			return;
		}
		if(system.countShipsWithRole('vector_inspection')) this.insp.ins = system.shipsWithRole('vector_inspection')[0];
		let stationCorridor = new Vector3D(this.insp.station.position.subtract(system.mainPlanet.position)),corridorVector = new Vector3D(player.ship.position.subtract(this.insp.station.position));
		let distToStation = corridorVector.magnitude();
		let distToCorridor = distToStation*Math.sin(stationCorridor.angleTo(corridorVector));
		let sdist = player.ship.position.distanceTo(this.insp.station.position);
		if(distToCorridor<300 || sdist<4000){
			if(!this.insp.wait){
				if(distToCorridor<300){
					this.setSound(12);
					if(player.ship.targetSystem!==system.ID) player.commsMessage(this.insp.station.name+": Clear docking corridor and stop your engines and rudder. Do not try to jump. Over.");
					else player.commsMessage(this.insp.station.name+": Clear docking corridor and stop your engines and rudder. Don't try to flee. Over.");
				} else {
					this.setSound(13);
					if(player.ship.targetSystem!==system.ID) player.commsMessage(this.insp.station.name+": Clear danger zone and stop your engines and rudder. Do not try to jump. Over.");
					else player.commsMessage(this.insp.station.name+": Clear danger zone and stop your engines and rudder. Don't try to flee. Over.");
				}
			} else {
				if(this.insp.wait>5){
					player.bounty += 70;
					player.commsMessage(this.insp.station.name+": Hostile vessel. Face the consequences! Over and out.");
					this.insp.station.launchPatrol();
					this.insp.penalty += 1000;
					this.backFrom(15,1);
				}
			}
			++this.insp.wait;
			return;
		} else {
			if(sdist>18000){
				player.commsMessage(this.insp.station.name+": This time we don't have the time to inspect your ship. Good luck out there. Over and out.");
				this.backFrom(17,1);
				delete this.insp;
				return;
			}
			if(player.ship.speed!==0){
				if(this.insp.warn===0){
					this.setSound(18);
					this.insp.station.launchPatrol();
					player.commsMessage(this.insp.station.name+": Stop your engines and rudder for ship inspection. Over.");
				} else if(this.insp.warn===1){
					this.insp.up = player.ship.vectorUp;
				} else if(this.insp.warn===2){
					this.insp.penalty += 100;
					this.setSound(16);
					this.insp.station.launchPatrol();
					player.commsMessage(this.insp.station.name+": Stop your engines immediately or we will stop you! Over.");
				} else if(this.insp.warn===3){
					player.bounty += 60;
					this.insp.penalty += 1000;
					this.insp.station.launchPatrol();
					player.commsMessage(this.insp.station.name+": Hostile vessel. Face the consequences! Over and out.");
					this.backFrom(15,1);
				}
				++this.insp.warn;
				return;
			} else {
				if(this.insp.loop===4 && (this.insp.vU.dot(player.ship.vectorUp)<0.999 || this.insp.pos!==player.ship.position.x)){
					player.bounty += 50;
					this.insp.penalty += 1000;
					player.commsMessage(this.insp.station.name+": Hostile vessel. Face the consequences. Over and out.");
					this.backFrom(15,1);
				} else if(this.insp.loop===3){
					this.insp.vU = player.ship.vectorUp;
					this.insp.pos = player.ship.position.x;
				} else if(this.insp.loop===2 && (this.insp.vU.dot(player.ship.vectorUp)<0.999 || this.insp.pos!==player.ship.position.x)){
					this.insp.penalty += 100;
					this.setSound(16);
					player.commsMessage(this.insp.station.name+": This is our last warning. Stop! Over.");
					this.insp.station.launchPatrol();
				} else if(this.insp.loop===1){
					this.insp.vU = player.ship.vectorUp;
					this.insp.pos = player.ship.position.x;
					this.insp.station.launchPatrol();
				} else if(this.insp.loop===0){
					this.setSound(18);
					this.insp.station.launchShipWithRole('vector_inspection',true);
					this.insp.station.launchPatrol();
					player.commsMessage(this.insp.station.name+": Stop and await inspection team. Over.");
				}
				++this.insp.loop;
				return;
			}
		}
	}
	return;
}
this.backFrom = function(sound,abort)
{
	if(abort) if(this.inspectionTimer){this.inspectionTimer.stop(); delete this.inspectionTimer;}
	this.setSound(sound);
	if(this.insp.ins && this.insp.ins.isValid) this.insp.ins.AIState = 'RETURN_TO_SENDER';
	if(worldScripts["BGS-M"]) worldScripts["BGS-M"].bgsDisableChatter = false;
	return;
}
this.setSound = function(newSound)
{
	if(!this.mySound) return;
	switch(newSound){
		case 3: this.mySound.sound = 'vector_inspection.ogg'; break;
		case 4: this.mySound.sound = '[vector_peep]'; break;
		case 11: this.mySound.sound = 'vector_insp_abort.ogg'; break;
		case 12: this.mySound.sound = 'vector_insp_clearcorridor.ogg'; break;
		case 13: this.mySound.sound = 'vector_insp_cleardangerzone.ogg'; break;
		case 13: this.mySound.sound = 'vector_insp_cleardangerzone.ogg'; break;
		case 14: this.mySound.sound = 'vector_insp_flee.ogg'; break;
		case 15: this.mySound.sound = 'vector_insp_hostile.ogg'; break;
		case 16: this.mySound.sound = 'vector_insp_lastwarning.ogg'; break;
		case 17: this.mySound.sound = 'vector_insp_luck.ogg'; break;
		case 18: this.mySound.sound = 'vector_insp_stop.ogg'; break;
	}
	this.mySound.play();
	return;
}
this.shipWillEnterWitchspace = function()
{
	if(this.inspectionTimer){this.inspectionTimer.stop(); delete this.inspectionTimer;}
	if(this.insp) delete this.insp;
	if(this.mySound){
		this.mySound.stop();
		delete this.mySound;
	}
}
this.playerStartedJumpCountdown = function()
{
	if(this.inspectionTimer && this.inspectionTimer.isRunning){
		this.backFrom(14,1);
		player.bounty += 50;
		player.commsMessage(this.insp.station.name+": Fleeing vessel. Face the consequences!");
	}
	if(this.insp) delete this.insp;
}
this.shipDied = function()
{
	if(this.inspectionTimer){this.inspectionTimer.stop(); delete this.inspectionTimer;}
	if(this.mySound) this.mySound.stop();
}
