"use strict";
this.name = "vector_missionArn";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Mission - Arn D'ercul";
this.version = "1.7.2";

this.startUp = function()
{
	delete this.startUp;
	if(!worldScripts.Cabal_Common_Functions || typeof(worldScripts.Cabal_Common_Functions.Cabal_Common)==='undefined'){this.killSelf(" -> Cabal_Common_Library is missing."); return;}
	var helper = new worldScripts.Cabal_Common_Functions.Cabal_Common();
	if(helper.internalVersion<14){this.killSelf(" -> Cabal_Common_Functions is too old."); return;}
	var requires = ["snoopers","2.3.2"];
	if(!helper.oxpVersionTest(this.name,requires)){this.killSelf(""); return;}
	if(missionVariables.vector_arn && missionVariables.vector_arn==='UNLIMITED' && missionVariables.TL_FOR_EQ_VECTOR_SCOOPS){this.killSelf(1); return;}
	delete this.killSelf;
	this.ov = new worldScripts.vector_news.VectorOV();
	this.logging = false;
	this.audio = true;
	this.extraB = true;
	this.init = true;
	this.allowS = false;
	this.mySound = new SoundSource;
	this.mySound.loop = true;
	this.hasShown = false;
	this.recalc = false;
	this.visitors = 0;
	this.compNews = 7;
	this.excludedScreens = ['GUI_SCREEN_OPTIONS','GUI_SCREEN_SAVE','GUI_SCREEN_LOAD','GUI_SCREEN_INTRO1','GUI_SCREEN_INTRO2','GUI_SCREEN_MISSION','GUI_SCREEN_REPORT'];
	if(!missionVariables.vector_arnmeet) missionVariables.vector_arnmeet = 0;
	if(missionVariables.vector_nextvisit){
		missionVariables.vector_arnnextvisit = missionVariables.vector_nextvisit;
		missionVariables.vector_nextvisit = null;
		mission.setInstructionsKey('VECTOR_ARNNEXTVISIT');
		missionVariables.vector_arnvisits = missionVariables.vector_visits;
		missionVariables.vector_visits = null;
	}
}
this.killSelf = function(desc)
{
	if(desc!==1){
		player.consoleMessage(this.name+" - Check your Latest.log.",10);
		log(this.name,this.name+" - Shutting down."+desc);
	}
	if(desc===1) missionVariables.vector_arnmeet = null; // CHECK
	for(prop in this){if(prop!=='name' && prop!=='version' && prop!=='oolite_manifest_identifier') delete this[prop];}
	this.deactivated = true;
	return;
}
this.grabSettings = function()
{
	if(missionVariables.vector_arnvisits) this.visitlist = missionVariables.vector_arnvisits.split(" ");
	this.logging = worldScripts.vector.logging;
	this.audio = worldScripts.vector.audio;
	this.extraB = worldScripts.vector.extraB;
	this.init = false;
	return;
}
this.shipWillDockWithStation = function()
{
	if(this.init) this.grabSettings();
	if(this.redo){
		player.addMessageToArrivalReport(this.redo);
		delete this.redo;
	}
	this.mySound.loop = true;
}
this.shipDockedWithStation = function()
{
	this.allowS = worldScripts.vector.allowS;
	this.hasShown = false;
	this.mySound.stop();
	this.visitors = 0;
}
this.missionScreenOpportunity = function()
{
	if(!player.ship.docked || this.hasShown || !this.allowS || (!missionVariables.vector_arn && missionVariables.vector_arnmeet<5)) return;
	this.grabSettings();
	this.missionOffers();
}
this.calculateVisits = function()
{
	if(galaxyNumber === 3){missionVariables.vector_arnnextvisit = "in the next galaxy"; return;}
	var myInfo = worldScripts.Cabal_Common_Functions.moreInfo,exSys = [6,23,55,70,128,133,162,178,194,229,247,251],setVisitlist = [],shortlist = [],checker = 0,i=256,t;
	while(i--){
		if(exSys.indexOf(i) !== -1) continue;
		t = myInfo.galaxyStats.contains(i);
		if(!t.sun || t.government !== 7) continue;
		setVisitlist.push(i);
	}
	var l = setVisitlist.length;
	if(l < 4){missionVariables.vector_arnnextvisit = "in the next galaxy"; player.commsMessage("Arn's friend was ordered to the next galaxy.",8); return;}
	for(var s=0;s<4;s++){
		checker = setVisitlist[Math.floor(Math.random()*l)];
		if(shortlist.indexOf(checker) != -1 || checker == system.ID) s--;
		else shortlist.push(checker);
	}
	shortlist.push(galaxyNumber);
	missionVariables.vector_arnvisits = shortlist.join(" ");
	mission.markSystem(shortlist[0]);
	missionVariables.vector_arnnextvisit = 'Major Hurst at '+myInfo.galaxyStats.contains(shortlist[0]).name+', galaxy '+(shortlist[4]+1);
	if(this.logging) log(this.name,'Calculated destinations:'+missionVariables.vector_arnvisits+" next name:"+myInfo.galaxyStats.contains(shortlist[0]).name);
	return;
}
this.getNextVisit = function(clr,nextName)
{
	mission.unmarkSystem(system.ID);
	if(clr){
		missionVariables.vector_arn = 'UNLIMITED';
		missionVariables.vector_arnnextvisit = null;
		missionVariables.vector_arnvisits = null;
		missionVariables.vector_aldrin = null;
		missionVariables.vector_arnrepeat = null;
		missionVariables.vector_arnmeet = null;
		mission.setInstructionsKey(null);
		this.visitors = 0;
	} else {
		missionVariables.vector_arn = 'VISIT'+String(this.currentStage+1);
		missionVariables.vector_arnnextvisit = nextName+' at '+System.systemNameForID(this.visitlist[this.currentStage])+', galaxy '+(parseInt(this.visitlist[4])+1);
		mission.markSystem(this.visitlist[this.currentStage]);
		mission.setInstructionsKey('VECTOR_ARNNEXTVISIT');
		worldScripts.vector_pad.addToLogbook("CAI &"+nextName+" at "+System.systemNameForID(this.visitlist[this.currentStage]));
	}
	return;
}
this.loser = function()
{
	this.showScreen('VISIT4NA',null,4,null);
	this.mySound.loop = true;
	this.mySound.sound = 'vector_stokitch.ogg';
	this.mySound.play();
	this.piLoop = 0;
	worldScripts.vector_pad.addToLogbook("CAW");
	if(!this.pickItemTimer) this.pickItemTimer = new Timer(this,this.pickItem,0,0.5);
	else if(!this.pickItemTimer.isRunning) this.pickItemTimer.start();
	missionVariables.vector_arn = 'RETRY4';
	return;
}
this.pickItem = function()
{
	if(guiScreen==='GUI_SCREEN_LOAD'){
		this.mySound.stop();
		this.piRestart = true;
	} else if(this.piRestart){
		this.mySound.play();
		delete this.piRestart;
	}
	this.piLoop++;
	if(this.piLoop<12) return;
	var eqList = ['EQ_ADVANCED_COMPASS','EQ_ADVANCED_NAVIGATIONAL_ARRAY','EQ_CLOAKING_DEVICE','EQ_DOCK_COMP','EQ_ECM','EQ_FUEL_INJECTION','EQ_FUEL_SCOOPS','EQ_ENERGY_BOMB',
		'EQ_ENERGY_UNIT','EQ_ESCAPE_POD','EQ_GAL_DRIVE','EQ_HEAT_SHIELD','EQ_MILITARY_JAMMER','EQ_MILITARY_SCANNER_FILTER','EQ_MULTI_TARGET','EQ_NAVAL_ENERGY_UNIT','EQ_NAVAL_SHIELD_BOOSTER',
		'EQ_SCANNER_SHOW_MISSILE_TARGET','EQ_SHIELD_BOOSTER','EQ_TARGET_MEMORY','EQ_WORMHOLE_SCANNER'];
	if(!player.ship.docked){
		this.pickItemTimer.stop();
		delete this.pickItemTimer;
		return;
	}
	var a = Math.floor(Math.random()*eqList.length);
	var b = eqList[a];
	if(player.ship.equipmentStatus(b)==='EQUIPMENT_OK'){
		player.ship.setEquipmentStatus(b,'EQUIPMENT_DAMAGED');
		var z = EquipmentInfo.infoForKey(b).name;
		if(guiScreen==='GUI_SCREEN_MISSION') mission.addMessageText("Uh, your "+z+" is gone.");
		else player.commsMessage("Uh, your "+z+" is gone.");
		worldScripts.vector_pad.addToLogbook("CAX &"+z);
	}
	this.piLoop = 0;
	return;
}
this.playerBoughtEquipment = function(equipmentKey)
{
	if(equipmentKey==='EQ_PASSENGER_BERTH'){
		if(missionVariables.vector_arn==='RETRY3B'){
			missionVariables.vector_arn = 'RETRY3';
			this.missionOffers();
		}
	}
	return;
}
this.missionOffers = function()
{
	if(!player.ship.docked || this.hasShown || !player.ship.dockedStation.isMainStation) return;
	if(!missionVariables.vector_arn){
		if(missionVariables.vector_arnmeet==5 && (!missionVariables.vector_arnrepeat || parseInt(missionVariables.vector_arnrepeat)<=clock.days)){
			if(player.ship.passengerCapacity && player.ship.passengerCapacity>player.ship.passengerCount){
				missionVariables.vector_arnrepeat = clock.days+31;
				var a = system.info.systemsInRange(7);
				missionVariables.vector_arnnextvisit = a[0].name;
				this.showScreen('ASKING','PASSAGE',7,1);
				return;
			}
		} else if(missionVariables.vector_arnmeet==6 && system.name===missionVariables.vector_arnnextvisit){
			player.ship.removeEquipment('EQ_VECTOR_ARNP');
			mission.setInstructionsKey(null);
			mission.unmarkSystem(system.ID);
			missionVariables.vector_arnrepeat = null;
			missionVariables.vector_arnmeet = null;
			missionVariables.vector_arn = 'SCOOPED';
			worldScripts.vector_pad.addToLogbook("CAH");
		}
	}
	if(missionVariables.vector_arn==='SCOOPED'){
		this.showScreen('SPECIAL','OFFERSPECIAL',6,1);
		return;
	}
	if(missionVariables.vector_arn && missionVariables.vector_arn!=='RETRY4'){
		if(missionVariables.vector_arnvisits){
			this.visitlist = missionVariables.vector_arnvisits.split(" ");
			if(this.visitlist[4]==galaxyNumber){
				if(!system.sun.hasGoneNova && !system.sun.isGoingNova){
					this.currentStage = parseInt(missionVariables.vector_arn[5]);
					if(system.ID==this.visitlist[this.currentStage-1]){
						switch(this.currentStage){
							case 1: worldScripts.vector_pad.addToLogbook("CAK"); this.getNextVisit(null,'Linda Bevenger');
								this.showScreen('VISIT1',null,1,1); this.visitors = 1; break;
							case 2: worldScripts.vector_pad.addToLogbook("CAL"); this.getNextVisit(null,'Aldrin Escobar');
								this.showScreen('VISIT2',null,2,1); this.visitors = 2; worldScripts.vector_pad.padInfos.areidis.codes[0] = '1'; break;
							case 3: if(missionVariables.vector_arn==='RETRY3B') break;
								missionVariables.vector_arnnextvisit = 'Pavel Stokitch at '+System.systemNameForID(this.visitlist[this.currentStage])+', galaxy '+(parseInt(this.visitlist[4])+1);
								if(player.ship.passengerCapacity && player.ship.passengerCapacity>player.ship.passengerCount){
									if(missionVariables.vector_arn==='RETRY3') this.showScreen('VISIT3A','OFFERPICKUP',3,1);
									else this.showScreen('VISIT3','OFFERPICKUP',3,1);
									break;
								} else {
									if(missionVariables.vector_arn==='RETRY3'){
										this.showScreen('VISIT3C',null,3,1); worldScripts.vector_pad.addToLogbook("CAN");
									} else {
										this.showScreen('VISIT3B',null,3,1); worldScripts.vector_pad.addToLogbook("CAM");
									}
									missionVariables.vector_arn = 'RETRY3B'; break;}
							case 4: if(player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_OK'){
								this.showScreen('VISIT4','QUESTIONA',4,1); worldScripts.vector_pad.addToLogbook("CAV");}
								else this.loser(); this.visitors = 3;
								break;
						}
					} else {
						if(missionVariables.vector_aldrin && system.ID==this.visitlist[3]){
							if(this.logging) log(this.name,this.name+': Visit Pavel without Aldrin.');
							this.loser();
						}
					}
				}
			}
		}
	}
	return;
}
this.choiceEvaluation = function(choice)
{
	if(!choice) return;
	switch(choice.substr(10,40)){
		case 'PASSAGEN': missionVariables.vector_arnnextvisit = null; missionVariables.vector_arnrepeat = clock.days+31; this.hasShown = true;
			worldScripts.vector_pad.addToLogbook("CAD");
			missionVariables.vector_arnmeet = 3;
			break;
		case 'PASSAGEY': mission.setInstructions("Bring Arn D'ercul to "+missionVariables.vector_arnnextvisit+".");
			mission.markSystem(System.systemIDForName(missionVariables.vector_arnnextvisit));
			missionVariables.vector_arnmeet = 6; player.ship.awardEquipment('EQ_VECTOR_ARNP'); this.visitors = 1; this.hasShown = true;
			worldScripts.vector_pad.addToLogbook("CAG "+missionVariables.vector_arnnextvisit); break;
		case 'HANDOVER': missionVariables.vector_arn = null; player.credits += 2000; this.showScreen('HANDED',null,6,1);
			if(worldScripts.vector_pad.padInfos.generic.expFactor<98) worldScripts.vector_pad.padInfos.generic.expFactor += 2;
			worldScripts.vector_pad.addToLogbook("CAE"); break;
		case 'RESCUE': this.calculateVisits(); missionVariables.vector_arn = 'VISIT1'; mission.setInstructionsKey('VECTOR_ARNNEXTVISIT');
			this.visitors = 1; this.showScreen('RESCUED',null,7,1); break;
		case 'PICKUP': worldScripts.vector_pad.addToLogbook("CAQ"); this.visitors = 1;
			this.getNextVisit(null,'Pavel Stokitch'); player.ship.awardEquipment('EQ_VECTOR_ALDRIN');
			this.showScreen('VISIT3E',null,3,1); this.hasShown = true; 
			if(!missionVariables.vector_aldrin) missionVariables.vector_aldrin = 1;
			if(player.ship.equipmentStatus('EQ_HEAT_SHIELD')==='EQUIPMENT_OK' && player.ship.equipmentStatus('EQ_FUEL_SCOOPS')==='EQUIPMENT_OK') mission.addMessageTextKey('VECTOR_ARNVISIT3F');
			break;
		case 'DENIED': this.showScreen('VISIT3D',null,3,1); this.hasShown = true; missionVariables.vector_arn = 'RETRY3';
			worldScripts.vector_pad.addToLogbook("CAP"); this.visitors = 1; break;
		case 'QSTART': this.showScreen('VISIT4A','QUESTIONB',4,1); this.visitors = 4; return;
		case 'QDENIED': this.loser(); this.visitors = 4; break;
		case 'QFA': this.loser(); this.visitors = 4; break;
		case 'QFB': this.showScreen('VISIT4B','QUESTIONC',4,1); this.visitors = 4; return;
		case 'QFC': this.loser(); this.visitors = 4; break;
		case 'QFD': this.loser(); this.visitors = 4; break;
		case 'QFE': this.showScreen('VISIT4C','QUESTIOND',4,1); this.visitors = 4; return;
		case 'QFF': this.showScreen('VISIT4C','QUESTIOND',4,1); this.visitors = 4; return;
		case 'QFG': this.showScreen('VISIT4C','QUESTIOND',4,1); this.visitors = 4; return;
		case 'QFH': this.showScreen('VISIT4D',null,5,1); this.getNextVisit(1); player.ship.awardEquipment('EQ_VECTOR_SCOOPS');
			player.ship.removeEquipment('EQ_VECTOR_ALDRIN');
			if(worldScripts.vector_pad.padInfos.areidis.codes[0]) worldScripts.vector_pad.addToLogbook("CAY","CAZ");
			else worldScripts.vector_pad.addToLogbook("CAZ");
			return;
		case 'QFI': this.loser(); this.visitors = 4; break;
		default: this.hasShown = true;
	}
	return;
}
this.shipWillLaunchFromStation = function(station)
{
	if(this.init) this.grabSettings();
	this.mySound.stop();
	if(this.pickItemTimer && this.pickItemTimer.isRunning) this.pickItemTimer.stop();
	if(this.visitors){
		system.addShips('vector_visitor',this.visitors,player.ship.position.add([0,0,9000]),2000);
		worldScripts.vector_news.arnvisitor = true;
		worldScripts.Cabal_Common_Music.changeStatus("vector_news",true);
		this.visitors = 0;
		return;
	}
	if(missionVariables.vector_arnmeet<5 && this.allowS && Math.random()<0.1 && system.government>4 && player.score>300 && worldScripts.vector_news.newsPointer[0]>2 && !system.countShipsWithRole('vector_arn')) station.launchShipWithRole('vector_arn');
}
this.shipLaunchedFromStation = function()
{
	if(missionVariables.vector_arn==='RETRY3B') missionVariables.vector_arn = 'RETRY3';
	else if(missionVariables.vector_arn==='RETRY4') missionVariables.vector_arn = 'VISIT4';
	if(!player.ship.passengerCapacity || player.ship.passengerCapacity<=player.ship.passengerCount){
		if(missionVariables.vector_arn==='VISIT4'){
			this.visitlist = missionVariables.vector_arnvisits.split(" ");
			if(this.visitlist[4]==galaxyNumber && player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_OK'){
				worldScripts.vector_pad.addToLogbook("CAR");
				this.currentStage = 2;
				this.getNextVisit(null,'Aldrin Escobar');
				player.ship.removeEquipment('EQ_VECTOR_ALDRIN');
				missionVariables.vector_arn = 'RETRY3';
				this.ov.addOv(1,'03',null,null,1);
				player.commsMessage("Aldrin: Oh, man. What the heck are you trying? Believe me, if I'm not there Pavel will kill you! Or you won't find him. You can pick me up again at "+System.systemNameForID(this.visitlist[this.currentStage])+'.');
			}
		} else if(missionVariables.vector_arnmeet==='6'){
			missionVariables.vector_arnmeet = 5;
			missionVariables.vector_arnrepeat = clock.days+31;
			if(player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_OK') player.ship.removeEquipment('EQ_VECTOR_ARNP');
			this.ov.addOv(1,'03',null,null,1);
			player.commsMessage("Arn: Hey man! That was not nice. And I really thought you'd help me.");
			mission.unmarkSystem(System.systemIDForName(missionVariables.vector_arnnextvisit));
			mission.setInstructionsKey(null);
		}
	}
	if(missionVariables.vector_arn==='SCOOPED' || player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_OK'){
		system.addShips('vector_visitor',1,player.ship.position.add([0,0,9000]),1000);
		this.ov.addOv(null,'10',1,null,"Maybe we can sneak through.");
		worldScripts.vector_news.arnvisitor = true;
		worldScripts.Cabal_Common_Music.changeStatus("vector_news",true);
	}
}
this.showScreen = function(text,offer,image,music)
{
	var ov = "full";
	if(!image) image = 0;
	switch(image){
		case 6: image = 'vector_arnmessage2.png'; music = 'vector_arnopener.ogg'; ov="fullmessage"; break;
		case 7: image = 'vector_arnrescued.png'; music = 'vector_arnvisit.ogg'; break;
		default: image = 'vector_arnvisit'+String(image)+'.png'; if(music) music = 'vector_arnvisit.ogg';
	}
	if(text) text = expandMissionText('VECTOR_ARN'+text);
	if(!this.audio) music = null;
	ov = "vector_ov"+ov+".png";
	if(offer){
		offer = 'VECTOR_ARN'+offer;
		mission.runScreen({title:player.ship.dockedStation.displayName,message:text,background:image,overlay:ov,choicesKey:offer,music:music},this.choiceEvaluation);
	} else mission.runScreen({title:player.ship.dockedStation.displayName,message:text,background:image,overlay:ov,music:music});
	return;
}
this.shipWillExitWitchspace = function()
{
	if(system.isInterstellarSpace) return;
	if(!missionVariables.vector_arn){
		if(missionVariables.vector_arnmeet==6 && player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_OK'){
			system.addShips('vector_visitor',1,player.ship.position.add([0,0,5000]),2000);
			worldScripts.vector_news.arnvisitor = true;
			worldScripts.Cabal_Common_Music.changeStatus("vector_news",true);
		} else if((clock.days&7)===this.compNews){
			if(worldScripts.vector_news.startNews(0)) this.compNews ^= 3;
		} else if(missionVariables.vector_arnmeet<5 && system.government>4 && player.score>300 && Math.random()<0.39 && worldScripts.vector_news.newsPointer[0]>2) system.addShipsToRoute('vector_arn',1,0.1,'wp');
	} else {
		if(this.recalc){
			this.calculateVisits();
			mission.setInstructionsKey('VECTOR_ARNNEXTVISIT');
			player.commsMessage("Locating Arn D'erculs friend.",8);
			this.recalc = false;
		}
		if(missionVariables.vector_arnvisits){
			if(missionVariables.vector_aldrin) missionVariables.vector_aldrin++;
			this.visitlist = missionVariables.vector_arnvisits.split(" ");
			if(this.visitlist[4]==galaxyNumber){
				this.currentStage = parseInt(missionVariables.vector_arn[5]);
				if(system.ID==this.visitlist[this.currentStage-1]){
					system.addShips('vector_visitor',this.currentStage,player.ship.position.add([0,0,5000]),2000);
					worldScripts.vector_news.arnvisitor = true;
					worldScripts.Cabal_Common_Music.changeStatus("vector_news",true);
					if(this.currentStage>2) worldScripts.vector_pad.addToLogbook("CAO "+system.name);
					if(system.sun.hasGoneNova || system.sun.isGoingNova){
						this.calculateVisits();
						mission.setInstructionsKey('VECTOR_ARNNEXTVISIT');
						player.commsMessage("Malfunction. Recalculating location of Arn D'erculs friend.",8);
					}
				} else {
					if(Math.random()<0.1){
						system.addShips('vector_visitor',1,player.ship.position.add([0,0,8000]),2000);
						worldScripts.vector_news.arnvisitor = true;
						worldScripts.Cabal_Common_Music.changeStatus("vector_news",true);
					} else if(player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_OK'){
						this.ov.addOv(null,'11',1,null,"Aldrin: Ok, let's go sundiving...");
					}
					if((clock.days&2) && worldScripts.vector_news.startNews(1)) this.compNews ^= 3;
				}
			}
		} else if((clock.days&7)===this.compNews){
			if(worldScripts.vector_news.startNews(2)) this.compNews ^= 3;
		}
	}
	if(this.logging) log(this.name,this.name+': N:'+worldScripts.vector_news.newsPointer+' C1:'+(clock.days&7)+' C3:'+(clock.days&7)+' C:'+this.compNews);
}
this.shipExitedWitchspace = function()
{
	if(missionVariables.vector_arn==='SCOOPED' || player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_OK'){
		this.ov.addOv(null,'10',1,null,"They have found us. Bring us to the station!",'vector_arn.ogg');
	}
}
this.shipEnteredPlanetaryVicinity = function(planet)
{
	if(!missionVariables.vector_aldrin) return;
	if(this.logging) log(this.name,this.name+': Sun:'+(planet.isSun)+' aldrinCount:'+missionVariables.vector_aldrin);
	if(planet.isSun && player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_OK'){
		if(Math.random()<0.4-(parseInt(missionVariables.vector_aldrin)*0.05)){
			if(this.audio){
				this.mySound.loop = false;
				this.mySound.sound = '[vector_peep]';
				this.mySound.play();
			}
			if(player.ship.equipmentStatus('EQ_HEAT_SHIELD')==='EQUIPMENT_OK'){
				player.commsMessage("WARNING! Heat shields malfunction. Radiation leaks in passenger berth.");
				player.ship.setEquipmentStatus('EQ_HEAT_SHIELD','EQUIPMENT_DAMAGED');
			} else player.commsMessage("WARNING! WARNING! Radiation leaks in passenger berth.");
			player.ship.setEquipmentStatus('EQ_VECTOR_ALDRIN','EQUIPMENT_DAMAGED');
		} else {
			this.ov.addOv(null,'11',1,null,"Wow! What a nice corona. Refuel and bring us out of here.");
			if(missionVariables.vector_aldrin<3) worldScripts.vector_pad.addToLogbook("CAU "+system.name);
		}
	}
}
this.playerEnteredNewGalaxy = function()
{
	if(missionVariables.vector_arnnextvisit && missionVariables.vector_arnnextvisit==='in the next galaxy') this.recalc = true;
}
this.playerjumpFailed = this.playerCancelledJumpCountdown = function()
{
	if(!system.isInterstellarSpace) this.recalc = false;
}
this.equipmentDamaged = this.equipmentDestroyed = function(equipmentKey)
{
	if(equipmentKey==='EQ_VECTOR_ARNP'){
		missionVariables.vector_arnmeet = 5;
		missionVariables.vector_arnrepeat = clock.days+15;
		if(player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_DAMAGED') player.ship.removeEquipment('EQ_VECTOR_ARNP');
		player.commsMessage("Arn D'ercul has been injured.");
		this.redo = "Arn D'ercul has been immediately transfered to hospital.";
		mission.unmarkSystem(System.systemIDForName(missionVariables.vector_arnnextvisit));
		mission.setInstructionsKey(null);
	} else if(equipmentKey==='EQ_VECTOR_ALDRIN'){
		this.ov.addOv(1,'03',null,null,1);
		worldScripts.vector_pad.addToLogbook("CAT");
		if(player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_DAMAGED') player.ship.removeEquipment('EQ_VECTOR_ALDRIN');
		player.commsMessage("Aldrin Escobar has been injured, so better stay away from Pavel Stokitch.");
		this.visitlist = missionVariables.vector_arnvisits.split(" ");
		this.currentStage = 2;
		if(this.visitlist[4]==galaxyNumber){
			this.getNextVisit(null,'Aldrin Escobar');
			missionVariables.vector_arn = 'RETRY3';
			this.redo = "Aldrin Escobar has been immediately transfered to hospital. Pick him up again at "+System.systemNameForID(this.visitlist[this.currentStage])+".";
		} else {
			missionVariables.vector_arn = 'VISIT2';
			this.redo = "Aldrin Escobar has been immediately transfered to hospital. Pick him up again in galaxy "+this.visitlist[4]+".";
		}
	}
	return;
}
this.guiScreenChanged = function(to)
{
	if(this.init && this.excludedScreens.indexOf(guiScreen)===-1) this.grabSettings();
	if(to==='GUI_SCREEN_SYSTEM_DATA'){
		if(missionVariables.vector_aldrin && this.visitlist[4]==galaxyNumber && player.ship.targetSystem==this.visitlist[3]){
			mission.addMessageText("Residence of Pavel Stokitch.");
		}
	}
}
this.alertConditionChanged = function()
{
	if(this.init) this.grabSettings();
	delete this.alertConditionChanged;
}
this.shipDied = function()
{
	this.mySound.stop();
}
