"use strict";
this.name = "vector_ovi";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Overlays Instruments and Special Point Markers";
this.version = "1.7.1";

this.shipSpawned = function()
{
	this.getSlot();
	this.cycle = parseInt(this.ship.scriptInfo.vector_ovcycle);
	if(this.ship.primaryRole==='vector_ov02') this.passPods(1);
	this.getMoveOutPos();
	if(!this.reposTimer) this.reposTimer = new Timer(this,this.repositionIt,0,3.81);
	delete this.shipSpawned;
}
this.getMoveOutPos = function()
{
	if(system.isInterstellarSpace || !system.sun || system.sun.isGoingNova || system.sun.hasGoneNova) this.moveOutPos = new Vector3D([100000,55550,0]);
	else this.moveOutPos = system.sun.position;
	this.moveOutPos = this.moveOutPos.multiply(20);
	return;
}
this.repositionIt = function()
{
	if(!player.ship.isValid || player.ship.docked){this.getRid(1,1); return;}
	if(!this.cycle){
		this.ship.position = this.moveOutPos.add([1000+this.ship.fuel,0,0]);
		this.getRid();
		return;
	}
	let a = player.ship.vectorForward.multiply(200.0*(this.ship.fuel+1)),b = player.ship.vectorUp.multiply(400.0*(this.ship.fuel+1));
	this.ship.position = player.ship.position.subtract(a).subtract(b);
	this.ship.orientation = player.ship.orientation;
	if(this.cycle>0) this.cycle--;
	return;
}
this.getRid = function(way,all)
{
	if(this.reposTimer) this.reposTimer.stop();
	missionVariables.vector_islot &= 0xffff-Math.pow(2,this.ship.fuel);
	if(way) this.ship.remove(true);
	if(all) missionVariables.vector_islot = null;
	else if(missionVariables.vector_islot==="0") missionVariables.vector_islot = null;
	return;
}
this.shipRemoved = function(suppressDeathEvent)
{
	delete this.shipDied;
	return;
}
this.shipDied = this.shipWillEnterWitchspace = function()
{
	this.getRid();
	return;
}
this.passPods = function(slot,simple)
{
	if(!slot && (!this.reposTimer || !this.reposTimer.isRunning)) this.getSlot();
	if(!simple){
		var d=0,c = worldScripts.vector_pad.padInfos.generic.cpods,e = worldScripts.vector_pad.padInfos.generic.epods;
		if(c) d = Math.pow(2,c)-1;
		if(e) for(let i=0;i<e;i++){d += Math.pow(2,i+5);}
		this.ship.energy = 100+d;
		player.consoleMessage("Cargo:"+c+" Pods:"+e);
	}
	this.cycle = parseInt(this.ship.scriptInfo.vector_ovcycle);
	if(!this.moveOutPos) this.getMoveOutPos();
	if(!this.reposTimer) this.reposTimer = new Timer(this,this.repositionIt,0,3.81);
	else {
		if(!this.reposTimer.isRunning){
			this.reposTimer.nextTime = clock.absoluteSeconds+1;
			this.reposTimer.start();
		}
	}
	delete this.shipSpawned;
	return;
}
this.getSlot = function()
{
	if(missionVariables.vector_islot===null) missionVariables.vector_islot = 0;
	var a = parseInt(missionVariables.vector_islot);
	for(var i=0;i<8;i++){
		var o = Math.pow(2,i);
		if(!(a&o)){
			this.ship.fuel = i;
			missionVariables.vector_islot = a+o;
			break;
		}
	}
	return;
}
// Later on I'll move it into a multiEQ script
this.activated = function(equipmentKey)
{
	switch(this.equipmentKey){
		case "EQ_VECTOR_SPACELANE":
			if(!system.countShipsWithRole('vector_ov01')) var a = system.addShips('vector_ov01',1,player.ship.position.add([5000,0,-500]))[0];
			else {
				var a = system.shipsWithRole('vector_ov01')[0];
				a.script.cycle = 0;
			}
			break;
		case "EQ_VECTOR_SCOOPS":
			if(!system.countShipsWithRole('vector_ov02')) var a = system.addShips('vector_ov02',1,player.ship.position.add([5000,0,-500]))[0];
			else {
				var a = system.shipsWithRole('vector_ov02')[0];
				a.script.passPods();
			}
			break;
	}
}
